// 2023 added variables and switch to reverse direction of the bar and make it easy to change sizes
// -g

// "True" to reverse
$GEnergy::Reversed = False;
// set this to the width and height pixel size of your FRAME (background)
$GEnergy::Framesize = "182 50";
// set this to the width and height pixel size of your BAR
$GEnergy::Barsize = "126 4";
// set this to the x and y distance your bar is from the top left edge of the hud/frame
$GEnergy::Offset = "28 2";


function GEnergy::Init() {
	if($GEnergy:Loaded)
		return;
	$GEnergy:Loaded = true;
	
	// HUD::New has no background - you can add the background by changing it to HUD::New::Shaded
	HUD::New( "GEnergy::Container", 0, 0, getWord($GEnergy::Framesize,0), getWord($GEnergy::Framesize,1), GEnergy::Wake, GEnergy::Sleep );
	
	newObject("GEnergy::EFrame", FearGuiFormattedText, 0, 0, getWord($GEnergy::Framesize,0), getWord($GEnergy::Framesize,1));
	newObject("GEnergy::EBar", FearGuiFormattedText, getWord($GEnergy::Offset,0), getWord($GEnergy::Offset,1), getWord($GEnergy::Barsize,0), getWord($GEnergy::Barsize,1));
	
	HUD::Add("GEnergy::Container","GEnergy::EFrame");
	HUD::Add("GEnergy::Container","GEnergy::EBar");
	
	Control::SetValue("GEnergy::EFrame", "<B0,0:Modules/HealthNrg/frame.png>");
	Control::SetValue("GEnergy::EBar", "<B0,0:Modules/HealthNrg/energybar.png>");
}

function GEnergy::Wake() { GEnergy::Update(); }
function GEnergy::Sleep() { Schedule::Cancel("GEnergy::Update();"); }

function GEnergy::Update() {
	Control::SetExtent("GEnergy::EBar", $energy * ( getWord($GEnergy::Barsize,0) / 100), getWord($GEnergy::Barsize,1) );
	
	// move bar over to simulate 'reversing' of the bar direction
	if($GEnergy::Reversed) {	
		%id = Control::getId("GEnergy::EBar");
		%xpos = getWord($GEnergy::Barsize,0) + getWord($GEnergy::Offset,0) - ($Energy * ( getWord($GEnergy::Barsize,0) / 100) );
		%y = getWord($GEnergy::Offset,1);
		%id.position =  %xpos ~ " " ~ %y;
	}
	// schedule next update
	Schedule::Add("GEnergy::Update();",0.1);
	
}

GEnergy::Init();