// 2023 added variables and switch to reverse direction of the bar and make it easy to change sizes
// -g

// "True" to reverse
$GHealth::Reversed = True;
// set this to the width and height pixel size of your FRAME (background)
$GHealth::Framesize = "182 50";
// set this to the width and height pixel size of your BAR
$GHealth::Barsize = "126 4";
// set this to the x and y distance your bar is from the top left edge of the hud/frame
$GHealth::Offset = "28 2";


function GHealth::Init() {
	if($GHealth:Loaded)
		return;
	$GHealth:Loaded = true;
	
	// HUD::New has no background - you can add the background by changing it to HUD::New::Shaded
	HUD::New( "GHealth::Container", 0, 0, getWord($GHealth::Framesize,0), getWord($GHealth::Framesize,1), GHealth::Wake, GHealth::Sleep );
	
	newObject("GHealth::HFrame", FearGuiFormattedText, 0, 0, getWord($GHealth::Framesize,0), getWord($GHealth::Framesize,1));
	newObject("GHealth::HBar", FearGuiFormattedText, getWord($GHealth::Offset,0), getWord($GHealth::Offset,1), getWord($GHealth::Barsize,0), getWord($GHealth::Barsize,1));
	
	HUD::Add("GHealth::Container","GHealth::HFrame");
	HUD::Add("GHealth::Container","GHealth::HBar");
	
	Control::SetValue("GHealth::HFrame", "<B0,0:Modules/HealthNrg/frame.png>");
	Control::SetValue("GHealth::HBar", "<B0,0:Modules/HealthNrg/healthbar.png>");
}

function GHealth::Wake() { GHealth::Update(); }
function GHealth::Sleep() { Schedule::Cancel("GHealth::Update();"); }

function GHealth::Update() {
	Control::SetExtent("GHealth::HBar", $Health * ( getWord($GHealth::Barsize,0) / 100), getWord($GHealth::Barsize,1) );
	
	// move bar over to simulate 'reversing' of the bar direction
	if($GHealth::Reversed) {	
		%id = Control::getId("GHealth::HBar");
		%xpos = getWord($GHealth::Barsize,0) + getWord($GHealth::Offset,0) - ($Health * ( getWord($GHealth::Barsize,0) / 100) );
		%y = getWord($GHealth::Offset,1);
		%id.position =  %xpos ~ " " ~ %y;
	}
	// schedule next update
	Schedule::Add("GHealth::Update();",0.1);
	
}

GHealth::Init();